/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2015                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/
#ifndef _FONTWIDGET_H
#define _FONTWIDGET_H

#include <QDialog>
#include <QFontComboBox>
#include <QSpinBox>

#define USE_DEFAULT "USE_DEFAULT"

// FontWidget is used to allow the user to define a font, font size, and
// line spacing for tree widgets

class FontWidget : public QDialog
{
    Q_OBJECT

signals:

    void
    apply( FontWidget* fontWidget );

private slots:

    void
    onOk();
    void
    onApply();
    void
    onCancel();

public:
    FontWidget( QWidget*       parent,
                const QString& family,
                int            pointSize );

    QFont
    getFont();
    QString
    getFontFamily();
    int
    getFontSize();

private:

    QFontComboBox* fontCombo;
    QComboBox*     sizeCombo;

    int familyIndex; // stores initial selected index of combo box, used for "Cancel"
    int sizeIndex;
};

#endif
