#include "TreeItemMarker.h"

QList<MarkerAttributes> MarkerAttributes::definedMarkers = QList<MarkerAttributes>();

MarkerAttributes::MarkerAttributes()
{
}

MarkerAttributes::MarkerAttributes( const QColor& c )
{
    color = c;
}

const QColor&
MarkerAttributes::getColor() const
{
    return color;
}

void
MarkerAttributes::release()
{
    definedMarkers.insert( 0, *this );
}

MarkerAttributes
MarkerAttributes::getMarkerAttributes()
{
    if ( definedMarkers.isEmpty() )
    {
        definedMarkers.append( MarkerAttributes( Qt::green ) );
        definedMarkers.append( MarkerAttributes( Qt::magenta ) );
        definedMarkers.append( MarkerAttributes( Qt::red ) );
    }
    else if ( definedMarkers.size() == 1 )
    {
        definedMarkers.append( MarkerAttributes( Qt::red ) );
    }
    return definedMarkers.takeFirst();
}

// =========================================================

TreeItemMarker::TreeItemMarker( const QString& label, const QIcon* icon ) // todo handle icon
{
    this->label     = label;
    this->icon      = icon;
    this->attribute = MarkerAttributes::getMarkerAttributes();
}

TreeItemMarker::~TreeItemMarker()
{
    attribute.release();
}

const MarkerAttributes&
TreeItemMarker::getAttributes() const
{
    return attribute;
}

const QString&
TreeItemMarker::getLabel() const
{
    return label;
}
